# Copyright (C) 2018-2020 by BDE ENS Paris-Saclay
# SPDX-License-Identifier: GPL-3.0-or-later

from rest_framework import serializers

from ..models import Permission, RolePermissions


class PermissionSerializer(serializers.ModelSerializer):
    """
    REST API Serializer for Permission types.
    The djangorestframework plugin will analyse the model `Permission` and parse all fields in the API.
    """

    class Meta:
        model = Permission
        fields = '__all__'


class RolePermissionsSerializer(serializers.ModelSerializer):
    """
    REST API Serializer for RolePermissions types.
    The djangorestframework plugin will analyse the model `RolePermissions` and parse all fields in the API.
    """

    class Meta:
        model = RolePermissions
        fields = '__all__'
